com.orsoncharts.graphics3d.swing

## Class DisplayPanel3D

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JPanel
        - - com.orsoncharts.graphics3d.swing.DisplayPanel3D

- All Implemented Interfaces:
    java.awt.event.MouseListener, java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, java.util.EventListener, javax.accessibility.Accessible

      public class DisplayPanel3D
      extends javax.swing.JPanel
      implements java.awt.event.MouseListener

  A panel for displaying 3D content, with a toolbar and popup menu to control the view.
  NOTE: This class is serializable, but the serialization format is subject to change in future releases and should not be relied upon for persisting instances of this class.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class javax.swing.JPanel

      `javax.swing.JPanel.AccessibleJPanel`

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `javax.swing.JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `java.awt.Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

  - ### Field Summary

    - ### Fields inherited from class javax.swing.JComponent

      `listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DisplayPanel3D(Panel3D content)` Creates a new display panel for the given content, with a toolbar and popup menu configured.
    `DisplayPanel3D(Panel3D content, boolean toolbar, boolean popupMenu)` Creates a new display panel.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Panel3D` | `getContent()` Returns a reference to the content panel.
    `static java.awt.Font` | `getFontAwesomeFont(int size)` Returns a font for "Font Awesome" (http://fontawesome.io) at the specified size.
    `void` | `mouseClicked(java.awt.event.MouseEvent e)` This method does nothing.
    `void` | `mouseEntered(java.awt.event.MouseEvent e)` This method does nothing.
    `void` | `mouseExited(java.awt.event.MouseEvent e)` This method does nothing.
    `void` | `mousePressed(java.awt.event.MouseEvent e)` Checks if the popup is triggered in which case it is displayed.
    `void` | `mouseReleased(java.awt.event.MouseEvent e)` Checks if the popup is triggered in which case it is displayed.
    `void` | `setExportFormats(ExportFormat... formats)` Sets the list of export formats that will be shown in the popup menu.

    - ### Methods inherited from class javax.swing.JPanel

      `getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### DisplayPanel3D

          public DisplayPanel3D(Panel3D content)

      Creates a new display panel for the given content, with a toolbar and popup menu configured.
      Parameters:
        `content` - the content (`null` not permitted).

    - #### DisplayPanel3D

          public DisplayPanel3D(Panel3D content,
                                boolean toolbar,
                                boolean popupMenu)

      Creates a new display panel.
      Parameters:
        `content` - the content (`null` not permitted).
        `toolbar` - toolbar?
        `popupMenu` - popup menu?

  - ### Method Detail

    - #### getFontAwesomeFont

          public static java.awt.Font getFontAwesomeFont(int size)

      Returns a font for "Font Awesome" (http://fontawesome.io) at the specified size.
      Parameters:
        `size` - the point size.
      Returns:
        A font.

    - #### getContent

          public Panel3D getContent()

      Returns a reference to the content panel.
      Returns:
        A reference to the content panel.

    - #### setExportFormats

          public void setExportFormats(ExportFormat... formats)

      Sets the list of export formats that will be shown in the popup menu. If you provide an empty list, there will be no export submenu in the popup menu.
      Parameters:
        `formats` - the list of formats (`null` not permitted).
      Since:
        1.2

    - #### mouseClicked

          public void mouseClicked(java.awt.event.MouseEvent e)

      This method does nothing.
      Specified by:
        `mouseClicked` in interface `java.awt.event.MouseListener`
      Parameters:
        `e` - the mouse event.

    - #### mousePressed

          public void mousePressed(java.awt.event.MouseEvent e)

      Checks if the popup is triggered in which case it is displayed.
      Specified by:
        `mousePressed` in interface `java.awt.event.MouseListener`
      Parameters:
        `e` - the mouse event.

    - #### mouseReleased

          public void mouseReleased(java.awt.event.MouseEvent e)

      Checks if the popup is triggered in which case it is displayed.
      Specified by:
        `mouseReleased` in interface `java.awt.event.MouseListener`
      Parameters:
        `e` - the mouse event.

    - #### mouseEntered

          public void mouseEntered(java.awt.event.MouseEvent e)

      This method does nothing.
      Specified by:
        `mouseEntered` in interface `java.awt.event.MouseListener`
      Parameters:
        `e` - the mouse event.

    - #### mouseExited

          public void mouseExited(java.awt.event.MouseEvent e)

      This method does nothing.
      Specified by:
        `mouseExited` in interface `java.awt.event.MouseListener`
      Parameters:
        `e` - the mouse event.